   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*             CLIPS Version 6.20  01/31/02            */
   /*                                                     */
   /*           DEFRULE LHS PARSING HEADER FILE           */
   /*******************************************************/

/*************************************************************/
/* Purpose: Coordinates parsing of the LHS conditional       */
/*   elements of a rule.                                     */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_rulelhs
#define _H_rulelhs

#ifndef _H_expressn
#include <clips/expressn.h>
#endif
#ifndef _H_reorder
#include <clips/reorder.h>
#endif
#ifndef _H_scanner
#include <clips/scanner.h>
#endif
#ifndef _H_pattern
#include <clips/pattern.h>
#endif

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _RULELHS_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

LOCALE struct lhsParseNode           *ParseRuleLHS(void *,char *,struct token *,char *,int *);
LOCALE void                           PropagatePatternType(struct lhsParseNode *,struct patternParser *);

#endif




